% computes generators for the companion pencil associated 
% with a given polynomial P (coefficients ordered according 
% to usual matlab convention)
%
% in this version the polynomial coefficients appear as the
% last column of A
function [sigmaa,gv,hv,bv,z,w,db,gu,hu,bu,p,q]=companion_generators_col(P);

N=length(P)-1; % polynomial degree and matrix size
% check that P is in col form
sz=size(P);
if sz(1)<sz(2) 
    P=P.';
end
% compute generators for A
sigmaa=ones(N-1,1);
gv=zeros(N,2);
gv(1,1)=1;
hv=zeros(2,N);
hv(1,N)=1;
bv=zeros(2,2,N-1);
for j=1:N-1
    bv(:,:,j)=eye(2);
end
w=[zeros(N-1,1);1];
z=flipud(P(2:N+1));
z(1)=z(1)+1;
% compute generators for B
db=[ones(N-1,1);P(1)];
gu=zeros(N-1,1);
hu=zeros(1,N);  % actual generators are h(2:N)
bu=zeros(N-1,1); % actual generators are b(2:N-1)
p=[zeros(N-1,1);1];
q=[zeros(1,N-1),1-P(1)]';
